/*
Code VFO Version Arduino Mega 2560 avec TFT 3.5 by F4ITK - FI 32MHz
Version 1.9 - Avril 2024
*/

#include <LCDWIKI_GUI.h> //Core graphics library
#include <LCDWIKI_KBV.h> //Hardware-specific library


//definition de la carte
LCDWIKI_KBV lcd(ILI9486,A3,A2,A1,A0,A4); //model,cs,cd,wr,rd,reset

#define  BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE   0xFFFF
#define NAVY         0x000F 
#define DARKGREEN    0x03E0  
#define DARKCYAN     0x03EF 
#define MAROON       0x7800 
#define PURPLE       0x780F 
#define OLIVE        0x7BE0 
#define LIGHTGREY    0xC618 
#define DARKGREY     0x7BEF 
#define ORANGE       0xFD20 
#define GREENYELLOW  0xAFE5 
#define PINK         0xF81F 


#include <rotary.h>
#include <EEPROM.h>

//Setup some items
#define W_CLK 39   // oldPin 8 newPin39 - connect to AD9850 module word load clock pin (CLK)
#define FQ_UD 37   // oldPin 9 newPin37 - connect to freq update pin (FQ)
#define DATA 35   // olPin 10 newPin35 - connect to serial data load pin (DATA)
#define RESET 33  // olPin 11 newPin33 - connect to reset pin (RST) 
#define pulseHigh(pin) {digitalWrite(pin, HIGH); digitalWrite(pin, LOW); }
#define filtre12m 41 // Cde du filtre passe haut 12m sur sortie D41
#define filtre10m 43 // Cde du filtre passe haut 12m sur sortie D43
#define filtresans 45 // Cde sans filtre 80,40,30,20,17,15m sur sortie D45

Rotary r = Rotary(A8,A9); // sets the pins the rotary encoder uses.  Must be interrupt pins.

int_fast32_t rx=14074000; // Base (starting) frequency of VFO.  This only loads once.  To force load again see ForceFreq variable below.
int_fast32_t rx2=1; // variable to hold the updated frequency
int_fast32_t increment = 1000; // starting VFO update increment in HZ.
int_fast32_t iffreq = 31994643; // Intermedite Frequency - 
int buttonstate = 0;
int bandstate = 0;  // declaration etat bouton choix bande
int bandPosition = 17; // declaration position curseur pour affichage bande
int band = 20; // initialisation de la  valeur bande

int v = 35;//  Curseur frequence millions
long A =  0;//  Changement de mode USB ou LSB si different de 0
unsigned int mesureVcc; 
int  tension;
int tensionmv;

String  modeFT =  "FT8" ;

char chaine[17];  // chaine de caractere bande F
char chaineU[15];  // chaine de caractere V  de Vcc
char chaineUmv[02]; // chaine de caractere mV de Vcc

char chaineFa[14]; // chaine de caractere millions de F
char chaineFb[0]; // chaine de caractere hundredthousands de F
char chaineFc[7]; // chaine de caractere tenthousands de F
char chaineFd[4]; // chaine de caractere thousands de F
char chaineFe[0]; // chaine de caractere hundreds de F
char chaineFf[0]; // chaine de caractere tens de F
char chaineFg[0]; // chaine de caractere ones de F

int buttonstate2 = 0;
int GoIF = 1;
String hertz = "1 Khz";
int  hertzPosition = 8;
byte ones,tens,hundreds,thousands,tenthousands,hundredthousands,millions ;  //Placeholders
String freq; // string to hold the frequency
int_fast32_t timepassed = millis(); // int to hold the arduino miilis since startup
int memstatus = 1;  // value to notify if memory is current or old. 0=old, 1=current.
int ForceFreq = 1;  // Change this to 0 after you upload and run a working sketch to activate the EEPROM memory.  YOU MUST PUT THIS BACK TO 0 AND UPLOAD THE SKETCH AGAIN AFTER STARTING FREQUENCY IS SET!

const int bouton = 31; // bouton choix USB LSB
int etatBouton; // Variable qui enregistre l'etat du bouton

const int  VFO = 32;  // entrée VFO
int etatVFO; // Variable qui enregistre l'etat du VFO

const int Emission = 40; // entrée alim emission 5v
int etatEmission; // Variable qui enregistre l'etat du bouton

void setup() {
  // Initialisation de la carte TFT
  lcd.Init_LCD();
  
  // Mode paysage
  lcd.Set_Rotation(3);

  // Couleur du fond
  lcd.Fill_Screen(BLACK);

  // affichage du fond du texte en noir
  lcd.Set_Text_Back_colour(BLACK);

  // Couleur du texte 
  lcd.Set_Text_colour(GREEN);

  // paramétrage de la taille
  lcd.Set_Text_Size(5);
  
  // affichage Frequence
  lcd.Print("          MHz",50,50);

    // affichage Bande
    if (band  = 20)  { 
  lcd.Set_Text_colour(CYAN);
  lcd.Set_Text_Size(3);
  lcd.Print("Bande:   m",10,240);
  //lcd.Print("20",115,240);
  String(itoa(band,chaine,10));
  lcd.Print(chaine,115,240);
    }

  // affichage Mode
  lcd.Set_Text_colour(CYAN);
  lcd.Set_Text_Size(3);
  lcd.Print("Mode:",10,180);

   // affichage FT8  FT4
  lcd.Set_Text_colour(CYAN);
  lcd.Set_Text_Size(3);
  lcd.Print("FT8",200,180);

  // affichage Step
  lcd.Set_Text_colour(CYAN);
  lcd.Set_Text_Size(3);
  lcd.Print("STEP:",10,120);
  lcd.Print_String(hertz,110,120);

  // affichage VFO  OK
   lcd.Set_Text_colour(RED);
  lcd.Set_Text_Size(3);
  lcd.Print("VFO: OFF",300,180);
  lcd.Set_Draw_color(WHITE);
  lcd.Draw_Rectangle(285,165,460,215);
  

  // affichage Version
  lcd.Set_Text_colour(RED);
  lcd.Set_Text_Size(2);
  lcd.Print("VFO DDS version 1.9           by F4ITK ",10,290);

  // affichage VCC
  lcd.Set_Text_colour(LIGHTGREY);
  lcd.Set_Text_Size(2);
  lcd.Print("Vcc:     V ",350,5);  

  // affichage un rectangle
  lcd.Set_Draw_color(WHITE);
  lcd.Draw_Rectangle(20,35,460,100);
  
  
 //Initialisation liaison serie
 Serial.begin(9600);
 
 
  pinMode(A11,INPUT); // Entrée appui bouton KY-040
  digitalWrite(A11,HIGH);

  pinMode(A10,INPUT); // Entrée  bouton  choix bande
  digitalWrite(A10,HIGH);
  
  PCICR |= (1 << PCIE2);
  PCMSK2 |= (1 << PCINT16) | (1 << PCINT17);
  sei();
  
  pinMode(FQ_UD, OUTPUT);
  pinMode(W_CLK, OUTPUT);
  pinMode(DATA, OUTPUT);
  pinMode(RESET, OUTPUT); 
  
  pinMode(bouton,INPUT); // bouton LSB USB en entrée
  etatBouton = LOW; // on initialise l'etat bouton comme relaché

  pinMode(Emission,INPUT); // 5v emission en entrée
  etatEmission = LOW; // on initialise l'etat emission comme pas emission
  
  pulseHigh(RESET);
  pulseHigh(W_CLK);
  pulseHigh(FQ_UD);  // this pulse enables serial mode on the AD9850 - Datasheet page 12.

 pinMode(filtre12m,OUTPUT); // La D41 filtre12m est une sortie
 pinMode(filtre10m,OUTPUT); // La D43 filtre10m est une sortie
 pinMode(filtresans,OUTPUT); // La D45 filtresans est une sortie
 digitalWrite(filtresans,HIGH);// initialisation sans filtre passe haut
        
  // Load the stored frequency  
  
  if (ForceFreq == 0) {
    freq = String(EEPROM.read(0))+String(EEPROM.read(1))+String(EEPROM.read(2))+String(EEPROM.read(3))+String(EEPROM.read(4))+String(EEPROM.read(5))+String(EEPROM.read(6));
    rx = freq.toInt();  
  
}
}
void loop() {  
   {

  // Mesure  VCC
  mesureVcc = analogRead(A12);
  tension = mesureVcc * 5.0 * 304 /1023;
  lcd.Set_Text_colour(LIGHTGREY);
  lcd.Set_Text_Size(2);
  tension = ((tension/10)%10);
  tensionmv  = tension;
  
  // Affichage des diziemes de Vcc
  String(itoa(tensionmv,chaineUmv,10));
  lcd.Print(chaineUmv,440,5);
  lcd.Print (".",425,5); 

  // Affichage des unites de Vcc
  mesureVcc = analogRead(A12);
  tension = mesureVcc * 5.0 * 304 /1023;
  lcd.Set_Text_colour(LIGHTGREY);
  lcd.Set_Text_Size(2);
  tension = ((tension/100)%10);
  String(itoa(tension,chaineU,10));
  lcd.Print(chaineU,415,5); 

  // Affichage des dizaines de Vcc
  mesureVcc = analogRead(A12);
  tension = mesureVcc * 5.0 * 304 /1023;
  lcd.Set_Text_colour(LIGHTGREY);
  lcd.Set_Text_Size(2);
  tension = ((tension/1000)%10);
  String(itoa(tension,chaineU,10));
  lcd.Print(chaineU,403,5); 

    // affichage VFO OK ou OFF
    etatVFO = digitalRead(VFO); // lecture etat 
  if(etatVFO == LOW) // test si le VFO est OFF
  {
  lcd.Set_Text_colour(RED);
  lcd.Set_Text_Size(3);
  lcd.Print("VFO: OFF",300,180);
  }
  else //  si VFO est OK
  {
  lcd.Set_Text_colour(GREEN);
  lcd.Set_Text_Size(3);
  lcd.Print("VFO: OK ",300,180);
   } 
  
  //  affichage LSB  SSB  
  etatBouton = digitalRead(bouton); // lecture etat bouton 2
  if(etatBouton == LOW) // test si le bouton est au niveau haut
  {
  A = iffreq ; // Essai  
  lcd.Set_Text_colour(CYAN);
  lcd.Set_Text_Size(3);
  lcd.Print("LSB",110,180);  
  iffreq = 31998760;
  }
  
  else // test si le bouton est au niveau bas
  {
  A = iffreq ; // Essai  
  lcd.Set_Text_colour(CYAN);
  lcd.Set_Text_Size(3);
  lcd.Print("USB",110,180);
  iffreq = 31994643;
  }    
 
 //Test si changement mode LSB USB  
 if ((A-iffreq) == 0)
 
 {
 //Serial.print("A-iffreq : ");
 //Serial.println(A-iffreq);
 }
 else
 {
 rx2 = 1;// Mise à jour de la frequence si changement de mode USB ou LSB 
 }
 

// Affichage etat emission
  etatEmission = digitalRead(Emission); // lecture etat 5v Emission
  if(etatEmission == HIGH) // test si le 5v Emission est au niveau haut
  {
  lcd.Set_Draw_color(RED);
  lcd.Fill_Rectangle(250,110,432,150); 
  lcd.Set_Text_colour(BLACK);
  lcd.Set_Text_Size(3);
  lcd.Print("Emission",270,120); 
 }
  else // test si le 5v Emission est au niveau bas
  {
  lcd.Set_Draw_color(BLACK);
  lcd.Fill_Rectangle(250,110,432,150); 

  }
  
 //  affichage FT8  FT4
 if  (rx == 14074000){modeFT = "FT8";}
 else if (rx == 14080000){modeFT = "FT4";}
 else if (rx == 28074000){modeFT = "FT8";}
 else if (rx == 28180000){modeFT = "FT4";}
 else if (rx == 24915000){modeFT = "FT8";}
 else if (rx == 24919000){modeFT = "FT4";}
 else if (rx == 21074000){modeFT = "FT8";}
 else if (rx == 21140000){modeFT = "FT4";}
 else if (rx == 18100000){modeFT = "FT8";}
 else if (rx == 18104000){modeFT = "FT4";}
 else if (rx == 10136000){modeFT = "FT8";}
 else if (rx == 10140000){modeFT = "FT4";}
 else if (rx == 7074000){modeFT = "FT8";}
 else if (rx == 7047500){modeFT = "FT4";}
 else if (rx == 3573000){modeFT = "FT8";}
 else if (rx == 3575000){modeFT = "FT4";}
 else {modeFT = "    ";}
  {
  lcd.Set_Text_colour(CYAN);
  lcd.Set_Text_Size(3);
  lcd.Print_String(modeFT,200,180);
   }
 // fin affichage FT8 FT4
 
   }  
   
  // Update the display and frequency if the new Freq NEQ the old Freq  
  if (rx != rx2){   
        showFreq();
        sendFrequency(rx);
        rx2 = rx;        
      } 
        
  // Rotate through the rate of tuning as you hold down the button
  buttonstate = digitalRead(A11);
  if(buttonstate == LOW) {
        setincrement();        
    };

   // Prog  Bouton choix  bande
  bandstate = digitalRead(A10);
  if(bandstate == LOW) {
        setincrementa();        
    };
      
   // Write the frequency to memory if not stored and 2 seconds have passed since the last frequency change.
    if(memstatus == 0){   
      if(timepassed+2000 < millis()){
        storeMEM();
        }
      }  
    
 }
 
 
// Interrupt routine to catch the rotary encoder
ISR(PCINT2_vect) {
  unsigned char result = r.process();
  if (result) {    
    if (result == DIR_CW){rx=rx+increment;}
    else {rx=rx-increment;};       
      if (rx >=30000000){rx=rx2;}; // UPPER VFO LIMIT
      if (rx <=1000000){rx=rx2;}; // LOWER VFO LIMIT
  } 
}

// frequency calc from datasheet page 8 = <sys clock> * <frequency tuning word>/2^32
void sendFrequency(double frequency) {  
  //if (GoIF == 1){frequency=frequency-iffreq;}; //If pin = low, subtract the IF frequency.
  if (GoIF == 1){frequency=iffreq-frequency;}; //If pin = low, subtract the IF frequency.
  int32_t freq = frequency * 4294967295/(125000000-18500);  // note 125 MHz clock on 9850.  You can make 'slight' tuning variations here by adjusting the clock frequency.
  for (int b=0; b<4; b++, freq>>=8) {
    tfr_byte(freq & 0xFF);
  }
  tfr_byte(0x000);   // Final control byte, all 0 for 9850 chip
  pulseHigh(FQ_UD);  // Done!  Should see output

 Serial.print("FI OL : ");
 Serial.println(iffreq);
 Serial.print("Frequency : ");
 Serial.println(frequency);
 Serial.print("Freq : ");
 Serial.println(rx);
 Serial.println("fin2");
  
}



// transfers a byte, a bit at a time, LSB first to the 9850 via serial DATA line
void tfr_byte(byte data)
{
  for (int i=0; i<8; i++, data>>=1) {
    digitalWrite(DATA, data & 0x01);
    pulseHigh(W_CLK);   //after each bit sent, CLK is pulsed high
  }
}
//  Affichage de la valeur de STEP
void setincrement(){
  if(increment == 10){increment = 50; hertz = "50 Hz"; hertzPosition=7;}
  else if (increment == 50){increment = 100;  hertz = "100 Hz"; hertzPosition=6;}
  else if (increment == 100){increment = 500; hertz="500 Hz"; hertzPosition=6;}
  else if (increment == 500){increment = 1000; hertz="1 Khz"; hertzPosition=8;}
  else if (increment == 1000){increment = 2500; hertz="2.5 Khz"; hertzPosition=6;}
  else if (increment == 2500){increment = 5000; hertz="5 Khz"; hertzPosition=8;}
  else if (increment == 5000){increment = 10000; hertz="10 Khz"; hertzPosition=7;}
  else if (increment == 10000){increment = 100000; hertz="100 Khz"; hertzPosition=6;}
  else if (increment == 100000){increment = 1000000; hertz="1 Mhz"; hertzPosition=8;}  
  else{increment = 10; hertz = "10 Hz"; hertzPosition=7;};  
 
  lcd.Set_Text_colour(CYAN);
  lcd.Set_Text_Size(3);
  lcd.Print("             ",100,120);
  lcd.Print_String(hertz,110,120);
  
   delay(250); // Adjust this delay to speed up/slow down the button menu scroll speed.
};

//  Affichage de la bande et de la Freq correspondante FT8
void setincrementa(){
 if(band == 10){band = 12; rx=24915000;digitalWrite(filtre12m,HIGH);digitalWrite(filtre10m,LOW);digitalWrite(filtresans,LOW);}
 else if (band == 12){band = 15; rx=21074000;digitalWrite(filtresans,HIGH);digitalWrite(filtre12m,LOW);digitalWrite(filtre10m,LOW);}
 else if (band == 15){band = 17; rx=18100000;digitalWrite(filtresans,HIGH);digitalWrite(filtre12m,LOW);digitalWrite(filtre10m,LOW);}  
 else if (band == 17){band = 20; rx=14074000;digitalWrite(filtresans,HIGH);digitalWrite(filtre12m,LOW);digitalWrite(filtre10m,LOW);} 
 else if (band == 20){band = 30; rx=10136000;digitalWrite(filtresans,HIGH);digitalWrite(filtre12m,LOW);digitalWrite(filtre10m,LOW);}
 else if (band == 30){band = 40; rx=7074000;digitalWrite(filtresans,HIGH);digitalWrite(filtre12m,LOW);digitalWrite(filtre10m,LOW);}  
 else if (band == 40){band = 80; rx=3573000;digitalWrite(filtresans,HIGH);digitalWrite(filtre12m,LOW);digitalWrite(filtre10m,LOW);}
 else if (band = 10){band = 10; rx=28074000;digitalWrite(filtre12m,LOW);digitalWrite(filtre10m,HIGH);digitalWrite(filtresans,LOW);} 

  lcd.Set_Text_colour(CYAN);
  lcd.Set_Text_Size(3);
 String(itoa(band,chaine,10));
  lcd.Print(chaine,115,240);
  
 delay(250); // Adjust this delay to speed up/slow down the button menu scroll speed.
};

void showFreq(){
    millions = int(rx/1000000);
    hundredthousands = ((rx/100000)%10);
    tenthousands = ((rx/10000)%10);
    thousands = ((rx/1000)%10);
    hundreds = ((rx/100)%10);
    tens = ((rx/10)%10);
    ones = ((rx/1)%10);

    // Affichage de la frequence
  lcd.Set_Text_colour(GREEN);
  lcd.Set_Text_Size(5);
  lcd.Print("           MHz",35,50);

  if (millions > 9){v = 35;}
   else{v = 65;}
  String(itoa(millions,chaineFa,10));
  lcd.Print(chaineFa,v,50);
  lcd.Print(".",90,50);

  String(itoa(hundredthousands,chaineFb,10));
  lcd.Print(chaineFb,115,50);
  
  String(itoa(tenthousands,chaineFc,10));
  lcd.Print(chaineFc,155,50);

  String(itoa(thousands,chaineFd,10));
  lcd.Print(chaineFd,195,50);

  String(itoa(hundreds,chaineFe,10));
  lcd.Print(chaineFe,235,50);
  
  String(itoa(tens,chaineFf,10));
  lcd.Print(chaineFf,275,50);

  String(itoa(ones,chaineFg,10));
  lcd.Print(chaineFg,315,50);
  
   Serial.println  (rx);
   Serial.println  (band);
   Serial.println  (increment);
   Serial.println  (hundredthousands);
     
    timepassed = millis();
    memstatus = 0; // Trigger memory write
};

void storeMEM(){
  //Write each frequency section to a EPROM slot.  Yes, it's cheating but it works!
   EEPROM.write(0,millions);
   EEPROM.write(1,hundredthousands);
   EEPROM.write(2,tenthousands);
   EEPROM.write(3,thousands);
   EEPROM.write(4,hundreds);       
   EEPROM.write(5,tens);
   EEPROM.write(6,ones);   
   memstatus = 1;  // Let program know memory has been written
};
